Cannot browse Subversion paths that contain spaces
Resolution: Affected version:

Description

Whenever | try to browse a subversion path that contains spaces, | get a 502 proxy error with the message "Error reading from
remote server". In this case the SVN path was:
"http://grp-horus/bugs/repositories/browse/desktopmanager/trunk/applications/windows/resources%20status%20item"

I'm using redmine 0.8 on a mongrel 1.1.3 cluster with apache 2.2.8, subversion 1.5.1, MySQL 5.0.51a, ruby 1.8.6, rails 2.1.2.

The failing request log:

lun jan 19 10:12:02 +0100 2009: HTTP parse error, malformed request (127.0.0.1): #<Mongrel::HttpParserError: Invalid HTTP
format, parsing fails.>

lun jan 19 10:12:02 +0100 2009: REQUEST DATA: "GET
/bugs/repositories/browse/desktopmanager/trunk/applications/windows/resources status item HTTP/1.1\r\nHost:
127.0.0.1:8000\r\nUser-Agent: Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; en-US; rv:1.9.1b2) Gecko/20081201
Firefox/3.1b2\r\nAccept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\nAccept-Language:
en-us,en;q=0.5\r\nAccept-Encoding: gzip,deflate\r\nAccept-Charset: ISO-8859-1,utf-8;9=0.7,%;q=0.7\r\nReferer:
http://grp-horus/bugs/repositories/show/desktopmanager\r\nCookie: wikidbUserlD=25; wikidbUserName=Fsagnes;
wikidbToken=6aae9084c698f5d766df2dfdb2aadcbe; autologin=RFumjvGiU6zBtx2SutOKUacYe7tV1ZBRwg3Gtiym;
_session_id=5993d0605df86a9c26a102da1f4c8851\r\nVia: 1.1 grp-horus\r\nX-Forwarded-For: 192.168.8.142\r\nX-Forwarded-Host:
grp-horus\r\nX-Forwarded-Server: grp-horus\r\nConnection: Keep-Alive\r\n\r\n"

PARAMS: {"REQUEST_PATH"=>"/bugs/repositories/browse/desktopmanager/trunk/applications/windows/resources",
"REQUEST_URI"=>"/bugs/repositories/browse/desktopmanager/trunk/applications/windows/resources”,
"REQUEST_METHOD"=>"GET"}

The error page:

Proxy Error

The proxy server received an invalid response from an upstream server.

The proxy server could not handle the request GET
/bugs/repositories/browse/desktopmanager/trunk/applications/windows/resources status item.

Reason: Error reading from remote server

Apache/2.2.8 (Ubuntu) DAV/2 SVN/1.5.1 mod_fastcgi/2.4.6 mod_jk/1.2.25 mod_python/3.3.1 Python/2.5.2 PHP/5.2.4-2ubuntu5.4
with Suhosin-Patch mod_ssl/2.2.8 OpenSSL/0.9.8g mod_perl/2.0.3 Perl/v5.8.8 Server at grp-horus Port 80

Related issues:

Related to Redmine - Defect #5461: Cannot browse SVN Repositories with whites... Closed 2010-05-07
Related to Redmine - Defect #7505: Subversion: Repository URL with space not ... Closed 2011-01-31
Related to Redmine - Defect #17882: Subversion: French character filename cau... New

History

#1 - 2009-01-23 18:41 - Jean-Philippe Lang

I'm not able to reproduce this error. Please provide the application log.

#2 - 2009-04-21 11:40 - Antonio Garcia-Dominguez
- File browsing-dir-with-space.png added
http://grp-horus/bugs/repositories/show/desktopmanager%5Cr%5CnCookie

- File browsing-subdir.png added

We have also experienced this issue on our Redmine 0.7.9 installation. The exact issue seems to be browsing a subdirectory of a path that contains a
space. For some reason, the URLs that are produced for these subdirectories are escaped by Redmine, containing "%20", which our browser (Mozilla
Firefox 3.0.8, as packaged by Canonical in Ubuntu Intrepid 8.10) escapes once more to "%2520", which obviously does not exist.

The last two lines from the Mongrel log (translated from Spanish to English) are:

svn: The URL 'http://neptuno.uca.es/svn-private/sources—fm/src/Takuan%2520Plugin/src' does not exist in that r
evision

svn: The URL 'http://neptuno.uca.es/svn-private/sources—fm/src/Takuan%$2520Plugin/src' does not exist in that r
evision

| have attached two more screenshots which | hope will clarify the problem.

| have looked around a bit and the issue seems to be (please correct me if I'm wrong) in the way "svn list" produces its entries, and how its output is
parsed in source:trunk/lib/redmine/scm/adapters/subversion_adapter.rb. If | do this (supplying the required authentication credentials):

svn list —--xml "http://neptuno.uca.es/svn/sources—fm/src/Takuan Plugin"
| obtain the following output, which as you can see, contains the infamous "%20":

<?xml version="1.0"7?>

<lists>

<list
path="http://neptuno.uca.es/svn/sources—fm/src/Takuan%20Plugin">

<entry

kind="file">
<name>build.xml</name>
<size>481</size>
<commit

revision="445">
<author>alejandro</author>
<date>2009-04-21T08:32:21.243736%Z</date>
</commit>
</entry>
<entry

kind="file">
<name>manifest.mf</name>
<size>227</size>
<commit

revision="445">
<author>alejandro</author>
<date>2009-04-21T08:32:21.243736%Z</date>
</commit>
</entry>
<entry

kind="dir">
<name>nbproject</name>
<commit

revision="445">
<author>alejandro</author>
<date>2009-04-21T08:32:21.243736z</date>
</commit>
</entry>
<entry

kind="dir">
<name>src</name>
<commit

revision="445">
<author>alejandro</author>
<date>2009-04-21T08:32:21.243736%Z</date>
</commit>
</entry>
<entry

kind="dir">
<name>test</name>
<commit

revision="445">
<author>alejandro</author>
<date>2009-04-21T08:32:21.243736z</date>
</commit>
</entry>
</list>
</lists>

Perhaps the URLs read from Subversion might need unescaping at some point before they're printed out?
Thanks in advance.

#3 - 2009-05-21 04:22 - Grant McEwan

Did anyone fix this? as i'm suffering the same problem.

Grant

#4 - 2009-09-24 01:45 - Grant McEwan
- Assignee set to Jean-Philippe Lang

It appears this is still broken in 0.8.5?

#5 - 2014-09-16 03:49 - Toshi MARUYAMA
- Related to Defect #17882: Subversion: French character filename causes error 404 added

#6 - 2017-01-10 12:21 - Go MAEDA
- File path_name_with_spaces.png added

- Status changed from New to Closed

No problem in the current trunk (r16171).
root / dir name with spaces / subdir

Name Size F
file name with spaces.txt 6 Bytes
test.txt 5 Bytes
View revisions

Files
browsing-dir-with-space.png 66 KB 2009-04-21 Antonio Garcia-Dominguez
browsing-subdir.png 91.5 KB 2009-04-21 Antonio Garcia-Dominguez
path_name_with_spaces.png 10.1 KB 2017-01-10 Go MAEDA
